#if defined __LCC__ && __LCC__ < 124

typedef struct {
	unsigned long long lo;
	unsigned long long hi;
} __uint128_t;

__uint128_t str2ulll(unsigned char *p, unsigned char **end, int base)
{
	__uint128_t n = {0};
	unsigned long long m;
	int sign = 0;

	while (*p <= ' ')
		p++;
	if (*p == '-') {
		sign++;
		p++;
	} else if (*p == '+')
		p++;
	if (base == 10) {
		while (*p > ' ') {
			n.hi = n.hi << 1 | n.lo >> 63;  // x2
			n.lo <<= 1;
			n.hi += n.hi << 2 | n.lo >> 62; // x5 (x1 + x4)
			m = n.lo;
			n.lo += n.lo << 2;
			if (n.lo < m)
				n.hi++;
			m = n.lo;
			n.lo += *p++ - '0';
			if (n.lo < m)
				n.hi++;
		}
	} else if (base == 16) {
		while (*p == '0' || *p == 'X' || *p == 'x')
			p++;
		for ( ; *p > ' '; p++) {
			n.hi = n.hi << 4 | n.lo >> 60;
			n.lo <<= 4;
			m = n.lo;
			n.lo += (*p & '\337') - (*p > '9' ? '7' : '\20');
			if (n.lo < m)
				n.hi++;
		}
	}
	if (end)
		*end = p;
	if (sign) {
		if ((n.lo = -n.lo) != 0)
			n.hi++;
		n.hi = -n.hi;
	}
	return n;
}

#else

__uint128_t str2ulll(unsigned char *p, unsigned char **end, int base)
{
	__uint128_t n = 0;
	int sign = 0;

	while (*p <= ' ')
		p++;
	if (*p == '-') {
		sign++;
		p++;
	} else if (*p == '+')
		p++;
	if (base == 10)
		while (*p > ' ')
			n = 10 * n + *p++ - '0';
	else if (base == 16) {
		while (*p == '0' || *p == 'X' || *p == 'x')
			p++;
		for ( ; *p > ' '; p++)
			n = 16 * n + (*p & '\337') - (*p > '9' ? '7' : '\20');
	}
	if (end)
		*end = p;
	if (sign)
		n = -n;
	return n;
}

#endif
