#if defined __LCC__ && __LCC__ < 124
typedef struct {
	unsigned long long lo;
	unsigned long long hi;
} __uint128_t;
#endif

__uint128_t str2ulll(unsigned char *, unsigned char **, int);

#include <stdio.h>
#ifdef __ARC64__
# include <unistd.h>
#endif

int main()
{
	__uint128_t m1, m2;
	unsigned long long m10, m11, m20, m21, p0, p1, p2, p3;
	char s[BUFSIZ];

	setvbuf(stdin, NULL, _IONBF, 0);
	setvbuf(stdout, NULL, _IONBF, 0);
	printf("Multiplicand 1 (128-bit hex): ");
	m1 = str2ulll((unsigned char *)fgets(s, sizeof(s), stdin), NULL, 16);
	printf("Multiplicand 2 (128-bit hex): ");
	m2 = str2ulll((unsigned char *)fgets(s, sizeof(s), stdin), NULL, 16);
#if defined __LCC__ && __LCC__ < 124
	m10 = m1.lo;
	m11 = m1.hi;
	m20 = m2.lo;
	m21 = m2.hi;
#else
	m10 = (unsigned long long) m1;
	m11 = (unsigned long long)(m1 >> 64);
	m20 = (unsigned long long) m2;
	m21 = (unsigned long long)(m2 >> 64);
#endif
	asm(
#if defined __aarch64__
		"ldr  x0,%4\n"
		"ldr  x1,%5\n"
		"ldr  x2,%6\n"
		"ldr  x3,%7\n"
		"bl umul128\n"
		"str  x0,%0\n"
		"str  x1,%1\n"
		"str  x2,%2\n"
		"str  x3,%3\n"
		: "=m" (p0), "=m" (p1), "=m" (p2), "=m" (p3)
		: "m" (m10), "m" (m11), "m" (m20), "m" (m21)
		: "x0", "x1", "x2", "x3"
#elif defined __ARC64__
		"ldl  r0,%4\n"
		"ldl  r1,%5\n"
		"ldl  r2,%6\n"
		"ldl  r3,%7\n"
		"bl umul128\n"
		"stl  r0,%0\n"
		"stl  r1,%1\n"
		"stl  r2,%2\n"
		"stl  r3,%3\n"
		: "=m" (p0), "=m" (p1), "=m" (p2), "=m" (p3)
		: "m" (m10), "m" (m11), "m" (m20), "m" (m21)
		: "r0", "r1", "r2", "r3"
#elif defined __s390__
                "lg   2,%4\n"
                "lg   3,%5\n"
                "lg   4,%6\n"
                "lg   5,%7\n"
                "stg  14,8(15)\n"
                "bras 14,umul128\n"
                "lg   14,8(15)\n"
                "stg  2,%0\n"
                "stg  3,%1\n"
                "stg  4,%2\n"
                "stg  5,%3\n"
		: "=m" (p0), "=m" (p1), "=m" (p2), "=m" (p3)
		: "m" (m10), "m" (m11), "m" (m20), "m" (m21)
		: "2", "3", "4", "5"
#elif defined __powerpc__ || defined __ppc__ || defined __PPC__
		"ld   r3,%4\n"
		"ld   r4,%5\n"
		"ld   r5,%6\n"
		"ld   r6,%7\n"
		"bl umul128\n"
		"nop\n"
		"std  r3,%0\n"
		"std  r4,%1\n"
		"std  r5,%2\n"
		"std  r6,%3\n"
		: "=m" (p0), "=m" (p1), "=m" (p2), "=m" (p3)
		: "m" (m10), "m" (m11), "m" (m20), "m" (m21)
		: "r3", "r4", "r5", "r6"
#elif defined __sparc
		"ldx  %4,%%o0\n"
		"ldx  %5,%%o1\n"
		"ldx  %6,%%o2\n"
		"ldx  %7,%%o3\n"
		"call umul128\n"
		"nop\n"
		"stx  %%o0,%0\n"
		"stx  %%o1,%1\n"
		"stx  %%o2,%2\n"
		"stx  %%o3,%3\n"
		: "=m" (p0), "=m" (p1), "=m" (p2), "=m" (p3)
		: "m" (m10), "m" (m11), "m" (m20), "m" (m21)
		: "%o0", "%o1", "%o2", "%o3"
#elif defined __mips__
		"ld   $4,%4\n"
		"ld   $5,%5\n"
		"ld   $6,%6\n"
		"ld   $7,%7\n"
		"bal umul128\n"
		"sd   $4,%0\n"
		"sd   $5,%1\n"
		"sd   $6,%2\n"
		"sd   $7,%3\n"
		: "=m" (p0), "=m" (p1), "=m" (p2), "=m" (p3)
		: "m" (m10), "m" (m11), "m" (m20), "m" (m21)
		: "$4", "$5", "$6", "$7"
#elif defined __riscv
		"ld   a0,%4\n"
		"ld   a1,%5\n"
		"ld   a2,%6\n"
		"ld   a3,%7\n"
		"jal umul128\n"
		"sd   a0,%0\n"
		"sd   a1,%1\n"
		"sd   a2,%2\n"
		"sd   a3,%3\n"
		: "=m" (p0), "=m" (p1), "=m" (p2), "=m" (p3)
		: "m" (m10), "m" (m11), "m" (m20), "m" (m21)
		: "a0", "a1", "a2", "a3", "t0", "t1", "t2"
#elif defined __loongarch__
		"ld.d $r4,%4\n"
		"ld.d $r5,%5\n"
		"ld.d $r6,%6\n"
		"ld.d $r7,%7\n"
		"bl umul128\n"
		"st.d $r4,%0\n"
		"st.d $r5,%1\n"
		"st.d $r6,%2\n"
		"st.d $r7,%3\n"
		: "=m" (p0), "=m" (p1), "=m" (p2), "=m" (p3)
		: "m" (m10), "m" (m11), "m" (m20), "m" (m21)
		: "$r4", "$r5", "$r6", "$r7"
#elif defined __alpha__
		"ldq  $16,%4\n"
		"ldq  $17,%5\n"
		"ldq  $18,%6\n"
		"ldq  $19,%7\n"
		"bsr umul128\n"
		"stq  $16,%0\n"
		"stq  $17,%1\n"
		"stq  $18,%2\n"
		"stq  $19,%3\n"
		: "=m" (p0), "=m" (p1), "=m" (p2), "=m" (p3)
		: "m" (m10), "m" (m11), "m" (m20), "m" (m21)
		: "$16", "$17", "$18", "$19"
#elif defined __hppa__
                "ldd  %4,%%r26\n"
                "ldd  %5,%%r25\n"
                "ldd  %6,%%r24\n"
                "ldd  %7,%%r23\n"
                "b,l umul128,%%r2\n"
                "nop\n"
                "std  %%r26,%0\n"
                "std  %%r25,%1\n"
                "std  %%r24,%2\n"
                "std  %%r23,%3\n"
		: "=m" (p0), "=m" (p1), "=m" (p2), "=m" (p3)
		: "m" (m10), "m" (m11), "m" (m20), "m" (m21)
		: "%r1", "%r2", "%r26", "%r25", "%r24", "%r23", "%r29"
#elif defined __amd64__
		"mov  %4,%%rdi\n"
		"mov  %5,%%rsi\n"
		"mov  %6,%%rdx\n"
		"mov  %7,%%rcx\n"
		"callq umul128\n"
		"mov  %%rdi,%0\n"
		"mov  %%rsi,%1\n"
		"mov  %%rdx,%2\n"
		"mov  %%rcx,%3\n"
		: "=m" (p0), "=m" (p1), "=m" (p2), "=m" (p3)
		: "m" (m10), "m" (m11), "m" (m20), "m" (m21)
		: "%rdi", "%rsi", "%rdx", "%rcx"
#elif defined __e2k__
		"ldd  %4,%%b[0]\n"
		"ldd  %5,%%b[1]\n"
		"ldd  %6,%%b[2]\n"
		"ldd  %7,%%b[3]\n"
		"disp %%ctpr1,umul128\n"
		"call %%ctpr1,wbs=20\n"
		"std  %0,%%b[0]\n"
		"std  %1,%%b[1]\n"
		"std  %2,%%b[2]\n"
		"std  %3,%%b[3]\n"
		: "=m" (p0), "=m" (p1), "=m" (p2), "=m" (p3)
		: "m" (m10), "m" (m11), "m" (m20), "m" (m21)
		: "%b[0]", "%b[1]", "%b[2]", "%b[3]"
#elif defined __ia64__
		"ld8  r8=%4\n"
		"ld8  r9=%5\n"
		"ld8  r10=%6\n"
		"ld8  r11=%7\n"
		"br.call.sptk rp=umul128\n"
		"st8  %0=r8\n"
		"st8  %1=r9\n"
		"st8  %2=r10\n"
		"st8  %3=r11\n"
		: "=m" (p0), "=m" (p1), "=m" (p2), "=m" (p3)
		: "m" (m10), "m" (m11), "m" (m20), "m" (m21)
		: "r8", "r9", "r10", "r11"
#elif defined __mmix__
		"ldo  $0,%4\n\t"
		"ldo  $1,%5\n\t"
		"ldo  $2,%6\n\t"
		"ldo  $3,%7\n\t"
		"geta $11,@+8\n\t"
		"jmp umul128\n\t"
		"sto  $0,%0\n\t"
		"sto  $1,%1\n\t"
		"sto  $2,%2\n\t"
		"sto  $3,%3\n"
		: "=m" (p0), "=m" (p1), "=m" (p2), "=m" (p3)
		: "m" (m10), "m" (m11), "m" (m20), "m" (m21)
		: "$0", "$1", "$2", "$3", "$4", "$5", "$6", "$7", "$8", "$9",
		 "$10", "$11"
#elif defined __tilegx__
		"ld   r0,%4\n"
		"ld   r1,%5\n"
		"ld   r2,%6\n"
		"ld   r3,%7\n"
		"jal umul128\n"
		"st   %0,r0\n"
		"st   %1,r1\n"
		"st   %2,r2\n"
		"st   %3,r3\n"
		: "=m" (p0), "=m" (p1), "=m" (p2), "=m" (p3)
		: "m" (m10), "m" (m11), "m" (m20), "m" (m21)
		: "r0", "r1", "r2", "r3", "r4", "r5", "r6", "r7", "r8", "r9",
		 "r10", "r11", "r12", "r13", "r14", "r15", "r16"
#else
#	error	<Αρχιτεκτονική?!>
#endif
	);
	printf("The product: %016llX%016llX%016llX%016llX\n", p3, p2, p1, p0);
#ifdef __ARC64__
	_exit(0);
#else
	return 0;
#endif
}
