// http://codeproject.com/Tips/618570/UInt-Multiplication-Squaring (Jacob F.W.)

void mult128to256(__uint128_t u, __uint128_t v, __uint128_t *h, __uint128_t *l)
{
	__uint128_t u1 = u & 0xFFFFFFFFFFFFFFFF;
	__uint128_t v1 = v & 0xFFFFFFFFFFFFFFFF;
	__uint128_t t = u1 * v1;
	__uint128_t w3 = t & 0xFFFFFFFFFFFFFFFF;
	__uint128_t k = t >> 64;
	u >>= 64;
	t = u * v1 + k;
	k = t & 0xFFFFFFFFFFFFFFFF;
	__uint128_t w1 = t >> 64;
	v >>= 64;
	t = u1 * v + k;
	k = t >> 64;
	*h = u * v + w1 + k;
	*l = (t << 64) + w3;
}

#include <stdio.h>

__uint128_t str2ulll(unsigned char *, unsigned char **, int);

int main()
{
	__uint128_t m1, m2, p0, p1;
	unsigned long long pA, pB, pC, pD;
	char s[BUFSIZ];

	printf("Multiplicand 1 (128-bit hex): ");
	m1 = str2ulll((unsigned char *)fgets(s, sizeof(s), stdin), NULL, 16);
	printf("Multiplicand 2 (128-bit hex): ");
	m2 = str2ulll((unsigned char *)fgets(s, sizeof(s), stdin), NULL, 16);
	mult128to256(m1, m2, &p1, &p0);
	pA = (unsigned long long)(p1 >> 64);
	pB = (unsigned long long) p1;
	pC = (unsigned long long)(p0 >> 64);
	pD = (unsigned long long) p0;
	printf("The product: %016llX%016llX%016llX%016llX\n", pA, pB, pC, pD);
	return 0;
}
